import { ModuleRoot } from "queenjs";
import { designAction } from "./module/actions/design";
import { initAction } from "./module/actions/init";
import { sourceAction } from "./module/actions/source";
import { helper } from "./module/helper";
import { https } from "./module/http";
import { sourceStore } from "./module/stores/source";

export class CollocationModule extends ModuleRoot {
  config = this.setConfig({});
  https = this.createHttps([https]);
  store = this.createStore(sourceStore);
  helper = this.createHelper(helper);
  actions = this.createActions([initAction, sourceAction, designAction]);
}

export const { initCollocation, useCollocation } =
  CollocationModule.hook("Collocation");
