import { css } from "@linaria/core";
import { IconClose } from "@queenjs/icons";
import { Space } from "ant-design-vue";
import { queenApi } from "queenjs";
import { defineComponent } from "vue";
import { useRouter } from "vue-router";

export default defineComponent({
  setup(props) {
    const router = useRouter();

    async function close() {
      if (history.state.canSave) {
        const ok = await queenApi.showConfirm({
          title: "提示",
          content: "退出款式设计，当前数据将丢失，是否继续退出。",
          okText: "确定",
        });
        if (!ok) return;
        router.go(-1);
      } else {
        router.go(-1);
      }
    }

    return () => {
      return (
        <div class={headerStyles}>
          <span class="title">智能搭配中心</span>
          {/* <TipIcon
            icon="undo"
            tip="撤销"
            onClick={() => history.undo()}
            disabled={!history.state.canUndo}
          />
          <TipIcon
            icon="redo"
            tip="重做"
            onClick={() => history.redo()}
            disabled={!history.state.canRedo}
          /> */}
          <div class="flex-1">
            {/* <RadioGroup
              class="radio_btns"
              data={ctx.webui.state.editTypeGroup}
              value={ctx.webui.state.editType}
              onChange={(v: any) => (ctx.webui.state.editType = v)}
            ></RadioGroup> */}
          </div>
          <Space>
            <IconClose
              class="icon_close"
              type="close"
              onClick={() => close()}
            />
          </Space>
        </div>
      );
    };
  },
});

const headerStyles = css`
  grid-area: header;
  height: 64px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  border-bottom: 1px solid #eaeaea;
  padding: 0 20px;
  background-color: #fff;
  .title {
    width: 140px;
    margin-right: 64px;
    font-size: 16px;
    font-weight: bold;
    color: #111111;
  }

  .icon_close {
    padding: 10px;
    font-size: 22px;
    font-weight: bold;
    cursor: pointer;
    &:hover {
      opacity: 0.8;
    }
    &:active {
      opacity: 0.6;
    }
  }
`;
