import { css } from "@linaria/core";
import { defineComponent } from "vue";
import Canvas3d from "./components/Canvas3d";
import Header from "./components/Header";
import RightPanel from "./components/RightPanel";
import SourcePanel from "./components/SourcePanel";

export default defineComponent({
  setup() {
    return () => {
      return (
        <div class={modalStyles}>
          <Header />
          <SourcePanel />
          <Canvas3d />
          <RightPanel />
        </div>
      );
    };
  },
});

const modalStyles = css`
  height: 100vh;
  display: grid;
  grid-template-areas:
    "header header header"
    "leftPanel content rightPanel";
  grid-template-columns: 400px auto 300px;
  grid-template-rows: 64px auto;
  background-color: #fff;
`;
