import { useCollocation } from "@/modules/collocation";
import { css } from "@linaria/core";
import { Image, List } from "@queenjs/ui";
import { Button, Checkbox, Empty, Pagination, Space } from "ant-design-vue";
import { useModal } from "queenjs";
import { computed, defineComponent, onMounted, reactive } from "vue";
import { object } from "vue-types";

export default defineComponent({
  props: {
    value: object(),
  },
  setup(props) {
    const modal = useModal();

    const collocation = useCollocation();

    const state = reactive({
      curScope: "user",
      curSelect: {
        _id: props.value?._id,
      } as any,
    });

    // const PageListController = computed(() => {
    //   if (state.curScope == "platform") {
    //     return ctx.queentree.actions.getPlatformPageList("shoes");
    //   }
    //   return ctx.queentree.actions.getTreePageList(
    //     state.curScope as any,
    //     "shoes",
    //     ctx.user.getUserType()
    //   );
    // });

    onMounted(() => {
      // ctx.design.UserList.loadPage(1);
      // PageListController.value.loadPage(1);
    });

    // const controller = {
    //   user: ctx.design.UserList,
    //   team: ctx.design.TeamList,
    //   company: ctx.design.CompanyList,
    // };

    const submit = async () => {
      // if (state.curSelect._id) {
      //   let res = await PageListController.value.AssetController.getScenePack(
      //     state.curSelect._id
      //   );
      //   modal.submit(res);
      //   return false;
      // }
      modal.submit(null);
    };

    const selectDesign = (item: any) => {
      state.curSelect = item;
    };

    return () => {
      const dataSource: any = [];
      return (
        <div class={modalStyle}>
          <div class="list_view">
            <List
              columns={5}
              gap="24px"
              data={dataSource}
              // data={PageListController.value.state.list}
            >
              {{
                item: (item: any) => (
                  <DesignItem
                    item={item}
                    key={item._id}
                    current={state.curSelect}
                    onClick={selectDesign}
                  />
                ),
                empty: () => {
                  return <Empty class="py-50px" type="default" />;
                },
              }}
            </List>
            <div class="text-center mt-30px mb-30px">
              <Pagination
                key={state.curScope}
                hideOnSinglePage
                // pageSize={PageListController.value.state.size}
                // hideOnSinglePage={true}
                // current={PageListController.value.state.page}
                // total={PageListController.value.state.total}
                // onChange={(p) => PageListController.value.loadPage(p)}
              />
            </div>
          </div>
          <div class="text-center">
            <Space>
              <Button onClick={() => modal.cancel()}>取消</Button>
              <Button type="primary" onClick={submit}>
                确认
              </Button>
            </Space>
          </div>
        </div>
      );
    };
  },
});

const DesignItem = defineComponent({
  props: ["item", "current", "onClick"],
  setup(props) {
    const thumbnailUrl = computed(() => {
      const { item } = props;

      const DefaultThumbnail = require("@/assets/images/default.png");
      let thumbnailUrl = DefaultThumbnail;
      if (item.thumbnail) {
        if (typeof item.thumbnail == "string") thumbnailUrl = item.thumbnail;
        else if (item.thumbnail.url) thumbnailUrl = item.thumbnail.url;
      }

      return thumbnailUrl;
    });

    return () => {
      const { current, item } = props;

      return (
        <div class={DesignItemStyle}>
          <div
            class="card_main"
            onClick={() => {
              props.onClick && props.onClick(item);
            }}
          >
            <div class="card_check">
              <Checkbox checked={item._id == current._id} />
            </div>
            <div class="thumbnail_card">
              <Image src={thumbnailUrl.value} size={300} class="card_img" />
            </div>
            <div class="card_footer">{item.name}</div>
          </div>
        </div>
      );
    };
  },
});

const modalStyle = css`
  background-color: #fff;
  overflow: hidden;
  .source_radio {
    text-align: center;
  }
  .list_view {
    margin-top: 20px;
  }
`;
const DesignItemStyle = css`
  width: 100%;
  background-color: rgba(255, 255, 255, 1);
  border: 1px solid #f5f6f7;
  cursor: pointer;
  overflow: hidden;
  .card_main {
    position: relative;
    .card_check {
      position: absolute;
      top: 5px;
      right: 5px;
    }
    .thumbnail_card {
      width: 100%;
      overflow: hidden;
    }

    .card_img {
      width: 100%;
      height: 150px;
      object-fit: cover;
    }
  }
  .card_footer {
    border-top: 1px solid #f5f6f7;
    padding: 15px;
    color: #333;
    width: 100%;
    font-size: 16px;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }
`;
