import { css } from "@linaria/core";
import { Button, Form, Input } from "ant-design-vue";
import { queenApi } from "queenjs";
import { defineComponent, reactive, ref } from "vue";
import Thumbnail from "./Thumbnail";

const layout = {
  labelCol: { span: 6 },
  wrapperCol: { span: 16 },
};

export default defineComponent({
  setup(props) {
    const modal = queenApi.useDialog();

    const formRef = ref();

    const formState = reactive({
      scenePack: {},
      name: "",
    });

    const submit = () => {
      formRef.value.validate().then(async (values: any) => {
        console.log("values: ", values);
      });
      // modal.cancel();
    };

    return () => {
      return (
        <div class={modalStyle}>
          <Form {...layout} ref={formRef} model={formState}>
            <Form.Item
              name="scenePack"
              label="选择款式"
              rules={[{ required: true, message: "款式不能为空" }]}
            >
              <Thumbnail
                v-model={[formState.scenePack, "value"]}
                // value={value}
                // values={values}
                // onChange={(v) => {
                //   values.name = v.name || null;
                //   emitChange(v);
                // }}
              />
            </Form.Item>
            <Form.Item
              name="name"
              label="款式名"
              rules={[{ required: true, message: "款式不能为空" }]}
            >
              <Input
                v-model={[formState.name, "value"]}
                placeholder="请输入款式名"
                // value={value == undefined ? values.scenePack?.name : value}
                onChange={(e: any) => {
                  // emitChange(e.target.value);
                }}
              />
            </Form.Item>
            <Form.Item class="text-center" wrapperCol={{ span: 24 }}>
              <Button onClick={() => modal.cancel()}>取消</Button>
              <Button type="primary" class="ml-10px" onClick={submit}>
                确定
              </Button>
            </Form.Item>
          </Form>
        </div>
      );
    };
  },
});

const modalStyle = css`
  .content {
    padding-top: 20px;
    padding-bottom: 10px;
    text-align: left;
  }

  .footer {
    margin-bottom: 0;
    text-align: right;
  }
`;
