import { useAuth } from "@queenjs-modules/auth";
import { Avatar, Button, Dropdown, Menu } from "ant-design-vue";
import { queenApi } from "queenjs";
import { defineComponent } from "vue";

export default defineComponent({
  setup() {
    const auth = useAuth();

    const goLogout = async () => {
      await auth.actions.logout();
    };

    const login = () => {
      queenApi.router.push("/login");
    };

    const menu = (
      <Menu>
        <Menu.Item onClick={goLogout}>
          <div>退出登录</div>
        </Menu.Item>
      </Menu>
    );

    return () => {
      const { userInfo } = auth.store;
      return (
        <>
          {userInfo._id ? (
            <Dropdown placement="bottom" overlay={menu}>
              <Avatar size={36} src={userInfo.avatar} />
            </Dropdown>
          ) : (
            <Button type="primary" size="small" onClick={() => login()}>
              登录
            </Button>
          )}
        </>
      );
    };
  },
});
